## flightgear 2024.1.4+dfsg

=== package/CMakeLists.txt ===

# this is the timestampe of when we ran Cmake, we could 
# switch to parsing this from flightgear/version file explicity,
# but it's only needed by AppStream metainfo for the moment

string(TIMESTAMP FG_CMAKE_TIMESTAMP "%Y-%m-%d")

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(DESKTOP_FILE_VERSION "1.0")
    
    if (ENABLE_QT)
        set(DESKTOP_FILE_RUN_ARGS "--launcher")
    endif()

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/org.flightgear.FlightGear.desktop.in"
        "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.desktop"
    )

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.desktop" 
        DESTINATION share/applications)

    # generate a metainfo file corresponding to this release
    configure_file (
        "${CMAKE_CURRENT_SOURCE_DIR}/org.flightgear.FlightGear.metainfo.xml.in"
        "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.metainfo.xml"
    )

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.metainfo.xml" DESTINATION share/metainfo)

# seperate install rules for AppDir creation
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.desktop" 
        DESTINATION appdir/usr/share/applications
        COMPONENT packaging)
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/org.flightgear.FlightGear.metainfo.xml" 
        DESTINATION appdir/usr/share/metainfo
        COMPONENT packaging)

    install(FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/FlightGear_app_icon.svg" 
        DESTINATION appdir/usr/share/icons
        RENAME flightgear.svg
        COMPONENT packaging)
endif()

=== test_suite/CMakeLists.txt ===
# CMake module includes.
include(SetupFGFSEmbeddedResources)
include(SetupFGFSIncludes)
include(SetupFGFSLibraries)
include(SetupMSVCGrouping)

# Add each test suite category.
foreach(test_category
        gui_tests
        simgear_tests
        system_tests
        unit_tests
        fgdata_tests
    )
    add_subdirectory(${test_category})
endforeach(test_category)

# Add the testing API.
add_subdirectory(FGTestApi)

# Add all test suite sources and headers.
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    bootstrap.cxx
    dataStore.cxx
    fgCompilerOutputter.cxx
    fgTestListener.cxx
    fgTestRunner.cxx
    formatting.cxx
    logging.cxx
    testSuite.cxx
)
set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    dataStore.hxx
    fgCompilerOutputter.hxx
    fgTestListener.hxx
    fgTestRunner.hxx
    formatting.hxx
    logging.hxx
)

# The test suite output directory.
set(TESTSUITE_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}")

# Get the CppUnit sources and headers to be built into the test suite.
if (NOT SYSTEM_CPPUNIT)
    message(STATUS "CppUnit: Building the FlightGear supplied CppUnit library")

    get_property(CPPUNIT_SOURCES GLOBAL PROPERTY CPPUNIT_SOURCES)
    get_property(CPPUNIT_HEADERS GLOBAL PROPERTY CPPUNIT_HEADERS)


    add_library(CppUnitLib STATIC ${CPPUNIT_SOURCES} ${CPPUNIT_HEADERS})

    target_include_directories(CppUnitLib PUBLIC "${PROJECT_SOURCE_DIR}/3rdparty/cppunit/include")
elseif(NOT TARGET CppUnitLib)
    message(FATAL_ERROR "CppUnit: system CppUnit library not found correctly")
else()
    message(STATUS "CppUnit: Linking to the system supplied CppUnit library")
endif()

#-----------------------------------------------------------------------------
# Set up all test suites as CTests.

# System test suites.
add_test(AeroMeshSystemTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -s AeroMeshTests)
#add_test(GPSSystemTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -s GPSTests)
add_test(InstancedSubsystemSystemTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -s InstancedSubsystemTests)
#add_test(NavaidsSystemTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -s NavaidsTests)
add_test(NonInstancedSubsystemSystemTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -s NonInstancedSubsystemTests)

# Unit test suites.
add_test(AddonManagementUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u AddonManagementTests)
add_test(AeroElementUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u AeroElementTests)
add_test(AircraftPerformanceUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u AircraftPerformanceTests)
add_test(AutosaveMigrationUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u AutosaveMigrationTests)
add_test(FlightplanUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u FlightplanTests)
add_test(FPNasalUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u FPNasalTests)
add_test(GPSUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u GPSTests)
add_test(HoldControllerUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u HoldControllerTests)
if(ENABLE_HID_INPUT)
    add_test(HIDInputUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u HIDInputTests)
endif()
add_test(LaRCSimMatrixUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u LaRCSimMatrixTests)
add_test(MktimeUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u MktimeTests)
add_test(NasalSysUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u NasalSysTests)
add_test(NasalSysUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u NasalLibTests)
add_test(NavaidsUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u NavaidsTests)
add_test(NavRadioUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u NavRadioTests)
add_test(PosInitUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u PosInitTests)
add_test(RNAVProcedureUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u RNAVProcedureTests)
add_test(RouteManagerUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u RouteManagerTests)
add_test(YASimAtmosphereUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -u YASimAtmosphereTests)

# GUI test suites.

# Simgear unit test suites.
add_test(CanvasSimgearUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -m CanvasTests)
add_test(MathGeodesySimgearUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -m MathGeodesyTests)
add_test(SimgearPropsSimgearUnitTests ${TESTSUITE_OUTPUT_DIR}/fgfs_test_suite --ctest -m SimgearPropsTests)

# FGData test suites.

#-----------------------------------------------------------------------------
# Set up the binary.

# Set up the embedded resources.
setup_fgfs_embedded_resources()

# Sort the sources and headers for MSVC.
setup_msvc_grouping()

# most object files come from fgfsObjects target: this property
# contains all the sources which need to be compiled seperately
# for the test-suite, becuase they depend on BUILDING_TESTSUTIE define
# we setup below via target_compile_definitions

get_property(TEST_SOURCES GLOBAL PROPERTY FG_TEST_SOURCES)

# Set up the separate executable for running the test suite.
add_executable(fgfs_test_suite
    ${TEST_SOURCES}
    ${TESTSUITE_SOURCES}
    ${TESTSUITE_HEADERS}
    $<TARGET_OBJECTS:fgfsObjects>
)

add_dependencies(fgfs_test_suite buildId)
set_target_properties(fgfs_test_suite
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${TESTSUITE_OUTPUT_DIR}"
)
if(ENABLE_AUTOTESTING)
    set(TEST_SUITE_COMMAND "fgfs_test_suite")
    set(TEST_SUITE_COMMENT "Running the full FlightGear test suite")
else()
    set(TEST_SUITE_COMMENT "Building the FlightGear test suite.")
endif(ENABLE_AUTOTESTING)

# Set up the target links.
setup_fgfs_libraries(fgfs_test_suite)
# Additional search paths for includes.
setup_fgfs_includes(fgfs_test_suite)

# test codce includes its headers as test_suite/foo.h, so we need this
target_include_directories(fgfs_test_suite PUBLIC ${PROJECT_SOURCE_DIR})

target_compile_definitions(fgfs_test_suite PUBLIC BUILDING_TESTSUITE)

# Additional libraries just for the test suite.
target_link_libraries(fgfs_test_suite CppUnitLib)

# target to run the tests
if (MSVC)
    file(TO_NATIVE_PATH "${FG_QT_BIN_DIR}" _qt_bin_dir_native)
    file(TO_NATIVE_PATH "${FINAL_MSVC_3RDPARTY_DIR}/bin" _msvc_3rdparty_bin_dir)
    file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" _install_bin_dir)

    set(CMAKE_MSVCIDE_RUN_PATH "${_install_bin_dir};${_msvc_3rdparty_bin_dir};${_qt_bin_dir_native}")
endif()

if (FG_QT_ROOT_DIR)
    # for QtPlatformHeaders
    target_include_directories(fgfs_test_suite PRIVATE ${FG_QT_ROOT_DIR}/include)
endif()


add_custom_target(test_suite
    ${TEST_SUITE_COMMAND}
    DEPENDS fgfs_test_suite
    COMMENT ${TEST_SUITE_COMMENT}
)

=== 3rdparty/hidapi/CMakeLists.txt ===


set(HIDAPI_SOURCES
    hidapi/hidapi.h
    hidapi/hidparse.h
    hidparser/hidparse.c
)

if (WIN32)
    list(APPEND HIDAPI_SOURCES 
        windows/hid.c
        windows/hidapi_cfgmgr32.h
        windows/hidapi_descriptor_reconstruct.c
        windows/hidapi_descriptor_reconstruct.h
        windows/hidapi_hidclass.h
        windows/hidapi_hidpi.h
        windows/hidapi_hidsdi.h)
elseif(APPLE)
    list(APPEND HIDAPI_SOURCES mac/hid.c)
else()
    list(APPEND HIDAPI_SOURCES linux/hid.c)
endif(WIN32)


#add_definitions( -DHAVE_CONFIG_H ) # to use fgfs config.h to get FG version, if needed
#add_definitions( -DLIBVER="SVN 261" ) # add an iaxclient_lib version string

add_library(hidapi STATIC
    ${HIDAPI_SOURCES}
)

if(WIN32)
    target_compile_definitions(hidapi
        # prevent marking functions as __declspec(dllexport) for static library build
        # #480: this should be refactored for v1.0
        PUBLIC HID_API_NO_EXPORT_DEFINE
    )

 #   target_link_libraries(hidapi PUBLIC SetupApi)
elseif(APPLE)
    find_library(IOKIT_FRAMEWORK IOKit)
    target_link_libraries(hidapi ${IOKIT_FRAMEWORK})
else()
    # Linux-y things
    find_package(UDev QUIET)
    if (UDEV_FOUND)
        target_link_libraries(hidapi ${UDEV_LIBRARIES})
    else()
		message(FATAL_ERROR "Failed to find UDev")
	endif()
endif()

target_include_directories(hidapi PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/hidapi)
target_include_directories(hidapi PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

# eof

=== src/GUI/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
 
  dialog.cxx
  gui.cxx
  gui_funcs.cxx
  layout-props.cxx
  layout.cxx
  menubar.cxx
  new_gui.cxx
  FGFontCache.cxx
  FGColor.cxx
    FileDialog.cxx
    MouseCursor.cxx
    MessageBox.cxx
    Highlight.cxx
  )

set(HEADERS
  dialog.hxx
  gui.h
  layout.hxx
  menubar.hxx
  new_gui.hxx
  FGFontCache.hxx
  FGColor.hxx
    FileDialog.hxx
    MouseCursor.hxx
    MessageBox.hxx
    Highlight.hxx
  )

if(WIN32)
  list(APPEND HEADERS WindowsMouseCursor.hxx
            FGWindowsMenuBar.hxx
            WindowsFileDialog.hxx)
  list(APPEND SOURCES WindowsMouseCursor.cxx
            FGWindowsMenuBar.cxx
            WindowsFileDialog.cxx)
endif()

if (APPLE)
    list(APPEND HEADERS FGCocoaMenuBar.hxx
        CocoaFileDialog.hxx
        CocoaMouseCursor.hxx
        CocoaHelpers.h
        CocoaHelpers_private.h)
    list(APPEND SOURCES FGCocoaMenuBar.mm
        CocoaFileDialog.mm
        CocoaMouseCursor.mm
        CocoaHelpers.mm)
endif()

if (HAVE_PUI)
  list(APPEND HEADERS 
    FGPUIMenuBar.hxx
    FGPUIDialog.hxx
    PUIFileDialog.hxx
    AirportList.hxx
    CanvasWidget.hxx
    MapWidget.hxx
    WaypointList.hxx
    property_list.hxx
  )

  list(APPEND SOURCES
    FGPUIMenuBar.cxx
    FGPUIDialog.cxx
    PUIFileDialog.cxx
    AirportList.cxx
    CanvasWidget.cxx
    MapWidget.cxx
    WaypointList.cxx
    fonts.cxx
    property_list.cxx
  )
endif()

if (HAVE_QT)
    if (QT_VERSION_MAJOR EQUAL "5")
      message(STATUS "Using Qt5 version of the macros")
      # Qt < 5.15 
      qt5_wrap_ui(uic_sources SetupRootDialog.ui
        )
      qt5_add_resources(qrc_sources resources.qrc)

      if (TARGET fgfs_qm_files)
        qt5_add_resources(qrc_sources ${PROJECT_BINARY_DIR}/translations.qrc)
      endif()
    else()
      message(STATUS "Using Qt6 version of the macros")
      # Qt 6 versions
      qt_wrap_ui(uic_sources SetupRootDialog.ui
        )
      qt_add_resources(qrc_sources resources.qrc)

      if (TARGET fgfs_qm_files)
        qt_add_resources(qrc_sources ${PROJECT_BINARY_DIR}/translations.qrc)
      endif()
    endif()



    add_library(fglauncher QtLauncher.cxx
                            QtLauncher.hxx
                            SettingsWrapper.hxx
                            LauncherMainWindow.hxx
                            LauncherMainWindow.cxx
                            BaseDiagram.cxx
                            BaseDiagram.hxx
                            AirportDiagram.cxx
                            AirportDiagram.hxx
                            CarrierDiagram.cxx
                            CarrierDiagram.hxx
                            NavaidDiagram.cxx
                            NavaidDiagram.hxx
                            SetupRootDialog.cxx
                            SetupRootDialog.hxx
                            UpdateDownloadedFGData.hxx
                            DownloadTerrasyncSharedData.hxx
                            DownloadTerrasyncSharedData.cxx
                            AircraftItemModel.hxx
                            AircraftItemModel.cxx
                            CatalogListModel.cxx
                            CatalogListModel.hxx
                            QtMessageBox.cxx
                            QtMessageBox.hxx
                            QtFileDialog.cxx
                            QtFileDialog.hxx
                            LocationController.cxx
                            LocationController.hxx
                            LauncherArgumentTokenizer.cxx
                            LauncherArgumentTokenizer.hxx
                            AircraftProxyModel.cxx
                            AircraftProxyModel.hxx
                            DefaultAircraftLocator.cxx
                            DefaultAircraftLocator.hxx
                            LaunchConfig.cxx
                            LaunchConfig.hxx
                            MPServersModel.cpp
                            MPServersModel.h
                            RecentAircraftModel.cxx
                            RecentAircraftModel.hxx
                            RecentLocationsModel.cxx
                            RecentLocationsModel.hxx
                            LauncherController.cxx
                            LauncherController.hxx
                            AddOnsController.cxx
                            AddOnsController.hxx
                            AddonsModel.cxx
                            AddonsModel.hxx
                            PixmapImageItem.cxx
                            PixmapImageItem.hxx
                            PathListModel.cxx
                            PathListModel.hxx
                            CarriersLocationModel.cxx
                            CarriersLocationModel.hxx
                            FavouriteAircraftData.cxx
                            FavouriteAircraftData.hxx
                            UpdateChecker.cxx
                            UpdateChecker.hxx
                            LauncherPackageDelegate.hxx
                            LauncherPackageDelegate.cxx
                            LauncherNotificationsController.hxx
                            LauncherNotificationsController.cxx
                            QtDNSClient.hxx
                            QtDNSClient.cxx
                            ${uic_sources}
                            ${qrc_sources}
                            ${qml_sources})

    set_property(TARGET fglauncher PROPERTY AUTOMOC ON)
    target_include_directories(fglauncher PRIVATE ${PROJECT_BINARY_DIR}/src/GUI 
      ${CMAKE_CURRENT_SOURCE_DIR})

    # we include WindowBuilder.h which needs this
    target_include_directories(fglauncher PRIVATE ${OPENSCENEGRAPH_INCLUDE_DIRS})

    target_link_libraries(fglauncher 
        Qt${QT_VERSION_MAJOR}::Core 
        Qt${QT_VERSION_MAJOR}::Widgets 
        Qt${QT_VERSION_MAJOR}::Network 
        Qt${QT_VERSION_MAJOR}::Qml 
        Qt${QT_VERSION_MAJOR}::Quick 
        Qt${QT_VERSION_MAJOR}::Svg 
        SimGearCore)

    add_library(fgqmlui 
                        PropertyItemModel.cxx
                        PropertyItemModel.hxx
                        FGQmlInstance.cxx
                        FGQmlInstance.hxx
                        FGQmlPropertyNode.cxx
                        FGQmlPropertyNode.hxx
                        QmlAircraftInfo.cxx
                        QmlAircraftInfo.hxx
                        LocalAircraftCache.cxx
                        LocalAircraftCache.hxx
                        PreviewImageItem.cxx
                        PreviewImageItem.hxx
                        ThumbnailImageItem.cxx
                        ThumbnailImageItem.hxx
                        QmlPropertyModel.hxx
                        QmlPropertyModel.cxx
                        QmlPositioned.hxx
                        QmlPositioned.cxx
                        QmlPositionedModel.cxx
                        QmlPositionedModel.hxx
                        QmlNavCacheWrapper.hxx
                        QmlNavCacheWrapper.cxx
                        QmlRadioButtonHelper.cxx
                        QmlRadioButtonHelper.hxx
                        QtHelpers.hxx
                        QtHelpers.cxx
                        UnitsModel.cxx
                        UnitsModel.hxx
                        NavaidSearchModel.hxx
                        NavaidSearchModel.cxx
                        FlightPlanController.cxx
                        FlightPlanController.hxx
                        RouteDiagram.cxx
                        RouteDiagram.hxx
                        StackController.cxx
                        StackController.hxx
                        ModelDataExtractor.cxx
                        ModelDataExtractor.hxx
                        HoverArea.cxx
                        HoverArea.hxx
                        PathUrlHelper.cxx
                        PathUrlHelper.hxx
                        DialogStateController.cxx
                        DialogStateController.hxx
                        GettingStartedTip.hxx
                        GettingStartedTip.cxx
                        GettingStartedTipsController.cxx
                        GettingStartedTipsController.hxx
                        TipBackgroundBox.cxx
                        TipBackgroundBox.hxx
                        GettingStartedScope.hxx
                        GettingStartedScope.cxx
                        QmlColoredImageProvider.hxx
                        QmlColoredImageProvider.cxx
                        QmlStringListModel.hxx
                        QmlStringListModel.cxx
                        )

    set_property(TARGET fgqmlui PROPERTY AUTOMOC ON)
    target_link_libraries(fgqmlui 
        Qt${QT_VERSION_MAJOR}::Widgets 
        Qt${QT_VERSION_MAJOR}::Network 
        Qt${QT_VERSION_MAJOR}::Qml 
        Qt${QT_VERSION_MAJOR}::Quick 
        Qt${QT_VERSION_MAJOR}::Svg 
        SimGearCore)

    target_include_directories(fgqmlui PRIVATE ${PROJECT_BINARY_DIR}/src/GUI ${OPENSCENEGRAPH_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
    
    if (TARGET fgfs_qm_files)
      add_dependencies(fglauncher fgfs_qm_files)
      add_dependencies(fgqmlui fgfs_qm_files)
    endif()

endif()


flightgear_component(GUI "${SOURCES}" "${HEADERS}")

=== src/Main/CMakeLists.txt ===
# CMake module includes.
include(FlightGearComponent)
include(SetupFGFSBundle)
include(SetupFGFSEmbeddedResources)
include(SetupFGFSIncludes)
include(SetupFGFSLibraries)
include(SetupMSVCGrouping)

# Set up the Main FG file sources and headers (excluding bootstrap.cxx and its main() function).
if(MSVC)
    set(MS_RESOURCE_FILE flightgear.rc)
endif(MSVC)

set(SOURCES

    fg_commands.cxx
    fg_init.cxx
    fg_io.cxx
    fg_os_common.cxx
    fg_scene_commands.cxx
    fg_props.cxx
    FGInterpolator.cxx
    globals.cxx
    locale.cxx
    logger.cxx
    main.cxx
    MultipleInstanceLock.cxx
    options.cxx
    positioninit.cxx
    screensaver_control.cxx
    subsystemFactory.cxx
    util.cxx
    XLIFFParser.cxx
    ErrorReporter.cxx
    ${MS_RESOURCE_FILE}
)

set(HEADERS
    AircraftDirVisitorBase.hxx
    fg_commands.hxx
    fg_init.hxx
    fg_io.hxx
    fg_props.hxx
    FGInterpolator.hxx
    globals.hxx
    locale.hxx
    logger.hxx
    main.hxx
    MultipleInstanceLock.hxx
    options.hxx
    positioninit.hxx
    screensaver_control.hxx
    subsystemFactory.hxx
    util.hxx
    XLIFFParser.hxx
    ErrorReporter.hxx
    sentryIntegration.hxx
)

flightgear_component(Main "${SOURCES}" "${HEADERS}" sentryIntegration.cxx)

# the main() function
set(MAIN_SOURCE
    bootstrap.cxx
    # we only want this file when building FGFS, so it can't be
    # part of fgfsObjects
    ${PROJECT_SOURCE_DIR}/src/Scripting/NasalUnitTesting.cxx
)

# Set up the embedded resources.
setup_fgfs_embedded_resources()

# Sort the sources and headers for MSVC.
setup_msvc_grouping()

# souerces which are different for fgfs vs the test-suite
get_property(TEST_SOURCES GLOBAL PROPERTY FG_TEST_SOURCES)


# important we pass WIN32 here so the console is optional. Other
# platforms ignore this option. If a console is needed we allocate
# it manually via AllocConsole()
# similarly pass MACOSX_BUNDLE so we generate a .app on Mac
add_executable(fgfs
    WIN32
    MACOSX_BUNDLE
    ${MAIN_SOURCE}
    ${TEST_SOURCES}
    $<TARGET_OBJECTS:fgfsObjects>
)

add_dependencies(fgfs buildId)
# explicitly disable automoc for main fgfs target
set_property(TARGET fgfs PROPERTY AUTOMOC OFF)

# MacOSX bundle packaging
if(APPLE)
    setup_fgfs_bundle(fgfs)
endif()

# Set up the target links.
setup_fgfs_libraries(fgfs)
export_debug_symbols(fgfs)
# Additional search paths for includes.
setup_fgfs_includes(fgfs)

add_executable(nasal
    nasal-bin.cxx
    ${PROJECT_SOURCE_DIR}/src/Scripting/sqlitelib.cxx
)
setup_fgfs_libraries(nasal)
install(TARGETS nasal RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(ENABLE_METAR)
    add_executable(metar metar_main.cxx)
    target_link_libraries(metar SimGearScene)
    install(TARGETS metar RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# ensure run/debug paths are set automatically in Visual Studio
if (MSVC)
  file(TO_NATIVE_PATH "${FG_QT_BIN_DIR}" _qt_bin_dir_native)
  file(TO_NATIVE_PATH "${FINAL_MSVC_3RDPARTY_DIR}/bin" _msvc_3rdparty_bin_dir)
  file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" _install_bin_dir)

  set_property(TARGET fgfs PROPERTY
  VS_GLOBAL_LocalDebuggerEnvironment "PATH=${_install_bin_dir};${_msvc_3rdparty_bin_dir};${_qt_bin_dir_native}")
endif()

=== src/Model/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	acmodel.cxx
	modelmgr.cxx
	panelnode.cxx
	validateSharedModels.cxx
	)

set(HEADERS
	acmodel.hxx
	modelmgr.hxx
	panelnode.hxx
	validateSharedModels.hxx
	)
    		
flightgear_component(Model "${SOURCES}" "${HEADERS}")

=== test_suite/FGTestApi/CMakeLists.txt ===
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/testGlobals.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/NavDataCache.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/PrivateAccessorFDM.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/scene_graph.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/TestPilot.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/NasalUnitTesting_TestSuite.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/TestDataLogger.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/testApis.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/testStringUtils.cxx
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/testGlobals.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/NavDataCache.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/PrivateAccessorFDM.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/scene_graph.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/TestPilot.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/TestDataLogger.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/testStringUtils.hxx
    PARENT_SCOPE
)

=== src/FDM/JSBSim/CMakeLists.txt ===
include(FlightGearComponent)

set(HEADERS
    FGFDMExec.h
    FGJSBBase.h
    JSBSim.hxx
    initialization/FGInitialCondition.h
    initialization/FGTrim.h
    initialization/FGTrimAxis.h
    input_output/FGXMLParse.h
    input_output/FGXMLFileRead.h
    input_output/FGPropertyReader.h
    input_output/FGPropertyManager.h
    input_output/FGScript.h
    input_output/FGfdmSocket.h
    input_output/string_utilities.h
    input_output/FGXMLElement.h
    input_output/net_fdm.hxx
    input_output/FGGroundCallback.h
    input_output/FGInputType.h
    input_output/FGInputSocket.h
    input_output/FGUDPInputSocket.h
    input_output/FGOutputFG.h
    input_output/FGOutputFile.h
    input_output/FGOutputSocket.h
    input_output/FGOutputTextFile.h
    input_output/FGOutputType.h
    input_output/FGModelLoader.h
    math/FGParameter.h
    math/LagrangeMultiplier.h
    math/FGColumnVector3.h
    math/FGCondition.h
    math/FGFunction.h
    math/FGLocation.h
    math/FGMatrix33.h
    math/FGModelFunctions.h
    math/FGPropertyValue.h
    math/FGQuaternion.h
    math/FGRealValue.h
    math/FGRungeKutta.h
    math/FGTable.h
    math/FGFunctionValue.h
    math/FGTemplateFunc.h
    models/FGAccelerations.h
    models/FGAerodynamics.h
    models/FGAircraft.h
    models/FGAtmosphere.h
    models/FGAuxiliary.h
    models/FGBuoyantForces.h
    models/FGExternalForce.h
    models/FGExternalReactions.h
    models/FGFCS.h
    models/FGGasCell.h
    models/FGSurface.h
    models/FGGroundReactions.h
    models/FGInertial.h
    models/FGInput.h
    models/FGLGear.h
    models/FGMassBalance.h
    models/FGModel.h
    models/FGOutput.h
    models/FGPropagate.h
    models/FGPropulsion.h
    models/atmosphere/FGStandardAtmosphere.h
    models/atmosphere/FGWinds.h
    models/atmosphere/FGMSIS.h
    models/atmosphere/MSIS/nrlmsise-00.h
    models/flight_control/FGAccelerometer.h
    models/flight_control/FGActuator.h
    models/flight_control/FGAngles.h
    models/flight_control/FGDeadBand.h
    models/flight_control/FGFCSComponent.h
    models/flight_control/FGFCSFunction.h
    models/flight_control/FGFilter.h
    models/flight_control/FGGain.h
    models/flight_control/FGGyro.h
    models/flight_control/FGKinemat.h
    models/flight_control/FGMagnetometer.h
    models/flight_control/FGPID.h
    models/flight_control/FGSensor.h
    models/flight_control/FGSensorOrientation.h
    models/flight_control/FGSummer.h
    models/flight_control/FGSwitch.h
    models/flight_control/FGWaypoint.h
    models/flight_control/FGDistributor.h
    models/flight_control/FGLinearActuator.h
    models/propulsion/FGElectric.h
    models/propulsion/FGEngine.h
    models/propulsion/FGForce.h
    models/propulsion/FGNozzle.h
    models/propulsion/FGPiston.h
    models/propulsion/FGPropeller.h
    models/propulsion/FGRocket.h
    models/propulsion/FGRotor.h
    models/propulsion/FGTank.h
    models/propulsion/FGThruster.h
    models/propulsion/FGTransmission.h
    models/propulsion/FGTurbine.h
    models/propulsion/FGTurboProp.h
    )

set(SOURCES
    FGFDMExec.cpp
    FGJSBBase.cpp
    JSBSim.cxx
    initialization/FGInitialCondition.cpp
    initialization/FGTrim.cpp
    initialization/FGTrimAxis.cpp
    input_output/FGGroundCallback.cpp
    input_output/FGPropertyReader.cpp
    input_output/FGPropertyManager.cpp
    input_output/FGScript.cpp
    input_output/FGXMLElement.cpp
    input_output/FGXMLParse.cpp
    input_output/FGXMLFileRead.cpp
    input_output/FGfdmSocket.cpp
    input_output/string_utilities.cpp
    input_output/FGInputType.cpp
    input_output/FGInputSocket.cpp
    input_output/FGUDPInputSocket.cpp
    input_output/FGOutputFG.cpp
    input_output/FGOutputFile.cpp
    input_output/FGOutputSocket.cpp
    input_output/FGOutputTextFile.cpp
    input_output/FGOutputType.cpp
    input_output/FGModelLoader.cpp
    math/FGColumnVector3.cpp
    math/FGCondition.cpp
    math/FGFunction.cpp
    math/FGLocation.cpp
    math/FGMatrix33.cpp
    math/FGModelFunctions.cpp
    math/FGPropertyValue.cpp
    math/FGQuaternion.cpp
    math/FGRealValue.cpp
    math/FGRungeKutta.cpp
    math/FGTable.cpp
    math/FGTemplateFunc.cpp
    models/FGAccelerations.cpp
    models/FGAerodynamics.cpp
    models/FGAircraft.cpp
    models/FGAtmosphere.cpp
    models/FGAuxiliary.cpp
    models/FGBuoyantForces.cpp
    models/FGExternalForce.cpp
    models/FGExternalReactions.cpp
    models/FGFCS.cpp
    models/FGGasCell.cpp
    models/FGSurface.cpp
    models/FGGroundReactions.cpp
    models/FGInertial.cpp
    models/FGInput.cpp
    models/FGLGear.cpp
    models/FGMassBalance.cpp
    models/FGModel.cpp
    models/FGOutput.cpp
    models/FGPropagate.cpp
    models/FGPropulsion.cpp
    models/atmosphere/FGStandardAtmosphere.cpp
    models/atmosphere/FGWinds.cpp
    models/atmosphere/FGMSIS.cpp
    models/atmosphere/MSIS/nrlmsise-00.c
    models/atmosphere/MSIS/nrlmsise-00_data.c
    models/flight_control/FGAccelerometer.cpp
    models/flight_control/FGActuator.cpp
    models/flight_control/FGAngles.cpp
    models/flight_control/FGDeadBand.cpp
    models/flight_control/FGFCSComponent.cpp
    models/flight_control/FGFCSFunction.cpp
    models/flight_control/FGFilter.cpp
    models/flight_control/FGGain.cpp
    models/flight_control/FGGyro.cpp
    models/flight_control/FGKinemat.cpp
    models/flight_control/FGMagnetometer.cpp
    models/flight_control/FGPID.cpp
    models/flight_control/FGSensor.cpp
    models/flight_control/FGSummer.cpp
    models/flight_control/FGSwitch.cpp
    models/flight_control/FGWaypoint.cpp
    models/flight_control/FGDistributor.cpp
    models/flight_control/FGLinearActuator.cpp
    models/propulsion/FGElectric.cpp
    models/propulsion/FGEngine.cpp
    models/propulsion/FGForce.cpp
    models/propulsion/FGNozzle.cpp
    models/propulsion/FGPiston.cpp
    models/propulsion/FGPropeller.cpp
    models/propulsion/FGRocket.cpp
    models/propulsion/FGRotor.cpp
    models/propulsion/FGTank.cpp
    models/propulsion/FGThruster.cpp
    models/propulsion/FGTransmission.cpp
    models/propulsion/FGTurbine.cpp
    models/propulsion/FGTurboProp.cpp
    )


add_library(JSBSim STATIC ${SOURCES} ${HEADERS})
set(VERSION_MESSAGE "compiled from FlightGear ${FLIGHTGEAR_VERSION}")
add_definitions("-DJSBSIM_VERSION=\"${VERSION_MESSAGE}\"")

target_link_libraries(JSBSim SimGearCore)
target_include_directories(JSBSim PRIVATE ${PROJECT_SOURCE_DIR}/src/FDM/JSBSim)

add_executable(JSBsim_bin JSBSim.cpp )
set_target_properties(JSBsim_bin PROPERTIES OUTPUT_NAME "JSBSim" )
target_Link_libraries(JSBsim_bin JSBSim)
target_include_directories(JSBsim_bin PRIVATE ${PROJECT_SOURCE_DIR}/src/FDM/JSBSim)

if (MSVC)
    set_target_properties(JSBsim_bin PROPERTIES DEBUG_POSTFIX d)
    target_compile_definitions(JSBSim PUBLIC JSBSIM_STATIC_LINK)
endif ()
install(TARGETS JSBsim_bin RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# eof

=== test_suite/unit_tests/Aircraft/CMakeLists.txt ===
# SPDX-FileCopyrightText: (C) 2025  James Turner <james@flightgear.org>
# SPDX-License-Identifier: GPL-2.0-or-later

set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_controls.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_history.cxx
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_controls.hxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_history.hxx
    PARENT_SCOPE
)

=== debian/changelog ===
flightgear (1:2024.1.4+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix typo in package name

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 05 Feb 2026 09:47:16 +0100

flightgear (1:2024.1.4+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Daniel Richard G. ]
  * Support <nocheck> build profile
  * Add libglew-dev to Build-Depends to allow building fgpanel

  [ Dr. Tobias Quathamer ]
  * New upstream version 2024.1.4+dfsg
    - Refresh patches
    - Remove patch, has been applied upstream
  * Update versioned Build-Dependencies to new packages
  * Use Qt6 instead of Qt5.
    Thanks to Bob Wong <ybx332@gmail.com>

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 30 Jan 2026 17:14:31 +0100

=== debian/control ===
Source: flightgear
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders:
 Ove Kaaven <ovek@arcticnet.no>,
 Markus Wanner <markus@bluegap.ch>,
Section: games
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 flightgear-data-ai (>= 1:2024.1.4~) <!nocheck>,
 flightgear-data-base (>= 1:2024.1.4~) <!nocheck>,
 flite1-dev,
 libboost-dev,
 libc-ares-dev,
 libcurl4-gnutls-dev,
 libdbus-1-dev,
 libevent-dev,
 libexpat1-dev,
 libgl-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libgsm1-dev,
 libhtsengine-dev,
 liblzma-dev,
 libopenal-dev,
 libopenscenegraph-dev,
 libplib-dev,
 libsimgear-dev (<= 1:2024.1.999),
 libsimgear-dev (>= 1:2024.1.4~),
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libudev-dev [linux-any],
 libudns-dev,
 libx11-dev,
 qt6-base-dev [!armel !armhf],
 qt6-base-private-dev [!armel !armhf],
 qt6-declarative-dev [!armel !armhf],
 qt6-declarative-private-dev [!armel !armhf],
 qt6-svg-dev,
 qt6-tools-dev,
 zlib1g-dev,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/debian/flightgear
Vcs-Git: https://salsa.debian.org/debian/flightgear.git
Homepage: https://www.flightgear.org/

Package: flightgear
Architecture: any
Depends:
 flightgear-data-all (>= 1:2024.1.4~),
 qml6-module-qtquick-window [!armel !armhf],
 qml6-module-qtquick [!armel !armhf],
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 flightgear-phi,
Conflicts:
 metar,
Description: Flight Gear Flight Simulator
 FlightGear Flight Simulator (often shortened to FlightGear or FGFS)
 is a sophisticated free, completely open-source flight simulator
 framework, created by volunteers.
 .
 This package contains the runtime binaries.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable all hardening options
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

#http://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH)
DEFAULT_BUILD_DIRECTORY = obj-$(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)

# Do not enable Qt on armel and armhf.
# libqt5opengl uses OpenGL ES on armel+armhf,
# simgear/flightgear use full OpenGL on all
# architectures, and the two can't be mixed.
# See https://bugs.debian.org/895332
ifneq (,$(findstring $(DEB_HOST_ARCH),armel armhf))
  ENABLE_QT = OFF
else
  ENABLE_QT = ON
endif

# Take care of excess precision of the x87 FPU.
# See https://bugs.debian.org/963200
ifneq (,$(filter $(DEB_HOST_ARCH), i386))
	export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE="RelWithDebInfo" \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-g -DNDEBUG" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_INSTALL_BINDIR:PATH=games \
	-DFG_DATA_DIR:PATH=/usr/share/games/flightgear \
	-DENABLE_LARCSIM=ON \
	-DENABLE_UIUC_MODEL=ON \
	-DENABLE_QT=$(ENABLE_QT) \
	-DSP_FDMS=ON \
	-DSYSTEM_SQLITE=ON \
	-DSYSTEM_SPEEX=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

execute_after_dh_installdocs:
	cp docs-mini/* debian/flightgear/usr/share/doc/flightgear || true
#	Drop README.Linux, it's outdated to the point of uselessness.
	rm $(CURDIR)/debian/flightgear/usr/share/doc/flightgear/README.Linux

	cp utils/TerraSync/README.txt debian/flightgear/usr/share/doc/flightgear/README.TerraSync


override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
override_dh_auto_test:
	cd $(DEFAULT_BUILD_DIRECTORY) && make fgfs_test_suite
	dh_auto_test --no-parallel
endif

# Some files and directories gets installed by accident.
execute_after_dh_auto_install:
	rm -rf $(CURDIR)/debian/flightgear/usr/appdir

=== debian/watch ===
Version: 5

Source: https://gitlab.com/api/v4/projects/flightgear%2F@PACKAGE@/repository/tags
Matching-Pattern: https://gitlab.com/flightgear/@PACKAGE@/.*/@PACKAGE@-v?@STABLE_VERSION@@ARCHIVE_EXT@
Pagemangle: s!"name":"(v?@STABLE_VERSION@)"!<a href="https://gitlab.com/flightgear/@PACKAGE@/-/archive/$1/@PACKAGE@-$1.tar.bz2">!g
Dversion-Mangle: auto
Repack-Suffix: +dfsg
